diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
index 2d12717ca..150e16702 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAlgae.java
@@ -37,20 +37,20 @@ public class BlockLogicAlgae
     public void onEntityCollision(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Entity entity) {
         if (entity instanceof EntityBoat) {
             world.playBlockEvent(null, tilePos, LevelListener.EVENT_BLOCK_BREAK, this.block.id());
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
     @Override
     public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        final int blockId = world.getBlockId(tilePos);
-        return blockId == 0 && Blocks.hasTag(world.getBlockId(tilePos.add(Direction.DOWN, new TilePos())), BlockTags.IS_WATER) && world.getBlockData(tilePos.add(Direction.DOWN, new TilePos())) == 0;
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+        return block == Blocks.AIR && world.getBlockType(tilePos.add(Direction.DOWN, new TilePos())).hasTag(BlockTags.IS_WATER) && world.getBlockData(tilePos.add(Direction.DOWN, new TilePos())) == 0;
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
-        if (!Blocks.hasTag(world.getBlockId(tilePos.add(Direction.DOWN, new TilePos())), BlockTags.IS_WATER) || world.getBlockData(tilePos.add(Direction.DOWN, new TilePos())) != 0) {
-            world.setBlockId(tilePos, 0);
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        if (!world.getBlockType(tilePos.add(Direction.DOWN, new TilePos())).hasTag(BlockTags.IS_WATER) || world.getBlockData(tilePos.add(Direction.DOWN, new TilePos())) != 0) {
+            world.setBlockType(tilePos, Blocks.AIR);
         }
     }
 
@@ -99,9 +99,9 @@ public class BlockLogicAlgae
                 for (int j = 0; j < i / 16; j++) {
                     checkX += rand.nextInt(3) - 1;
                     checkZ += rand.nextInt(3) - 1;
-                    final int bId = world.getBlockId(queryPos.set(checkX, checkY - 1, checkZ));
+                    final @NotNull Block<?> block = world.getBlockType(queryPos.set(checkX, checkY - 1, checkZ));
                     final int bMeta = world.getBlockData(queryPos.set(checkX, checkY - 1, checkZ));
-                    if (bId != Blocks.FLUID_WATER_FLOWING.id() && bId != Blocks.FLUID_WATER_STILL.id()) {
+                    if (block != Blocks.FLUID_WATER_FLOWING && block != Blocks.FLUID_WATER_STILL) {
                         continue outer;
                     }
                     if (bMeta != 0) {
@@ -109,11 +109,11 @@ public class BlockLogicAlgae
                     }
                 }
 
-                if (world.getBlockId(queryPos.set(checkX, checkY, checkZ)) != 0) {
+                if (world.getBlockType(queryPos.set(checkX, checkY, checkZ)) != Blocks.AIR) {
                     continue;
                 }
                 if (rand.nextFloat() > 0.75) {
-                    world.setBlockIdNotify(queryPos.set(checkX, checkY, checkZ), this.block.id());
+                    world.setBlockTypeNotify(queryPos.set(checkX, checkY, checkZ), this.block);
                 }
             }
             return true;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index 62c083fdc..43067d9e0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -93,7 +93,7 @@ public class BlockLogicBasket extends BlockLogic {
     public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
         TilePos queryPos = new TilePos();
         for (final @NotNull Direction d : Direction.directions) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(d, queryPos), this.id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(d, queryPos), this.block);
         }
     }
 
@@ -101,7 +101,7 @@ public class BlockLogicBasket extends BlockLogic {
     public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         TilePos queryPos = new TilePos();
         for (final @NotNull Direction d : Direction.directions) {
-            world.notifyBlocksOfNeighborChange(tilePos.add(d, queryPos), this.id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(d, queryPos), this.block);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index f77fe0923..8e88945a9 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -49,7 +49,7 @@ public class BlockLogicBed
 
         // Check if bed is not complete
         if (!isBlockHeadOfBed(data)) {
-            if (world.getBlock(footPos) != this.block) {
+            if (world.getBlockType(footPos) != this.block) {
                 return true;
             }
             data = world.getBlockData(tilePos);
@@ -57,9 +57,9 @@ public class BlockLogicBed
 
         // Explode in invalid dimensions
         if (!world.worldType.mayRespawn()) {
-            world.setBlockIdNotify(tilePos, 0);
-            if (world.getBlockId(footPos) == this.block.id()) {
-                world.setBlockIdNotify(footPos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
+            if (world.getBlockType(footPos) == this.block) {
+                world.setBlockTypeNotify(footPos, Blocks.AIR);
             }
             player.addStat(Achievements.SLEEP_NETHER, 1);
             world.createExplosion(null, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, 5F, true, false);
@@ -110,7 +110,7 @@ public class BlockLogicBed
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         this.removeOtherHalf(world, tilePos);
     }
 
@@ -123,11 +123,11 @@ public class BlockLogicBed
         final int data = world.getBlockData(tilePos);
         final int direction = getDirection(data);
         if (isBlockHeadOfBed(data)) {
-            if (world.getBlockId(tilePos.sub(headBlockToFootBlockMap[direction].getDirection(), new TilePos())) != this.block.id()) {
-                world.setBlockIdNotify(tilePos, 0);
+            if (world.getBlockType(tilePos.sub(headBlockToFootBlockMap[direction].getDirection(), new TilePos())) != this.block) {
+                world.setBlockTypeNotify(tilePos, Blocks.AIR);
             }
-        } else if (world.getBlockId(tilePos.add(headBlockToFootBlockMap[direction].getDirection(), new TilePos())) != this.block.id()) {
-            world.setBlockIdNotify(tilePos, 0);
+        } else if (world.getBlockType(tilePos.add(headBlockToFootBlockMap[direction].getDirection(), new TilePos())) != this.block) {
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
index b45fac098..166dc3ba5 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBedrock.java
@@ -16,7 +16,7 @@ public class BlockLogicBedrock
 
     @Override
     public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        if (world.getBlock(tilePos.add(Direction.DOWN, new TilePos())) == Blocks.GLOWSTONE) {
+        if (world.getBlockType(tilePos.add(Direction.DOWN, new TilePos())) == Blocks.GLOWSTONE) {
             Blocks.PORTAL_DRIFT.getLogic().tryToCreatePortal(world, tilePos, DyeColor.SILVER);
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
index 277f90080..c70e4b011 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBrazier.java
@@ -63,20 +63,19 @@ public class BlockLogicBrazier
         final @Nullable ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemFireStriker && !this.burning) {
             TilePos queryPos = new TilePos();
-            Block<?> b;
-            if ((b = world.getBlock(tilePos.add(Direction.EAST, queryPos))) != null && b.getLogic() instanceof BlockLogicFluid ||
-                (b = world.getBlock(tilePos.add(Direction.WEST, queryPos))) != null && b.getLogic() instanceof BlockLogicFluid ||
-                (b = world.getBlock(tilePos.add(Direction.SOUTH, queryPos))) != null && b.getLogic() instanceof BlockLogicFluid ||
-                (b = world.getBlock(tilePos.add(Direction.NORTH, queryPos))) != null && b.getLogic() instanceof BlockLogicFluid) {
+            if (world.getBlockType(tilePos.add(Direction.EAST, queryPos)).getLogic() instanceof BlockLogicFluid ||
+                world.getBlockType(tilePos.add(Direction.WEST, queryPos)).getLogic() instanceof BlockLogicFluid ||
+                world.getBlockType(tilePos.add(Direction.SOUTH, queryPos)).getLogic() instanceof BlockLogicFluid ||
+                world.getBlockType(tilePos.add(Direction.NORTH, queryPos)).getLogic() instanceof BlockLogicFluid) {
                 return false;
             }
-            world.setBlockIdDataNotify(tilePos, Blocks.BRAZIER_ACTIVE.id(), 0);
+            world.setBlockTypeNotify(tilePos, Blocks.BRAZIER_ACTIVE);
             heldItem.damageItem(1, player);
             world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "fire.ignite", 1.0F, world.rand.nextFloat() * 0.4F + 0.8F);
             return true;
         }
         if (heldItem == null && this.burning) {
-            world.setBlockIdDataNotify(tilePos, Blocks.BRAZIER_INACTIVE.id(), 0);
+            world.setBlockTypeNotify(tilePos, Blocks.BRAZIER_INACTIVE);
             return true;
         }
 
@@ -86,7 +85,7 @@ public class BlockLogicBrazier
     @Override
     public void onActivatorInteracted(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull TileEntityActivator activator, final @NotNull Direction direction) {
         if (this.burning) {
-            world.setBlockIdDataNotify(tilePos, Blocks.BRAZIER_INACTIVE.id(), 0);
+            world.setBlockTypeNotify(tilePos, Blocks.BRAZIER_INACTIVE);
         }
     }
 
@@ -98,11 +97,10 @@ public class BlockLogicBrazier
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!this.burning) return;
-        final @Nullable Block<?> block = Blocks.blocksList[id];
-        if (block != null && block.getLogic() instanceof BlockLogicFluid) {
-            world.setBlockIdDataNotify(tilePos, Blocks.BRAZIER_INACTIVE.id(), 0);
+        if (block.getLogic() instanceof BlockLogicFluid) {
+            world.setBlockTypeNotify(tilePos, Blocks.BRAZIER_INACTIVE);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index 6fbd9ad9e..100b70b02 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -197,7 +197,7 @@ public class BlockLogicButton
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         final boolean invalid;
         final int meta = world.getBlockData(tilePos);
         final int side = meta & MASK_DIRECTION;
@@ -212,7 +212,7 @@ public class BlockLogicButton
         };
         if (invalid) {
             this.dropWithCause(world, EnumDropCause.WORLD, tilePos, meta, null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
@@ -264,29 +264,29 @@ public class BlockLogicButton
         world.setBlockDataNotify(tilePos, (meta & ~MASK_DIRECTION) | direction | MASK_POWERED);
         world.markBlockDirty(tilePos);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.click", 0.3F, 0.6F);
-        world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
+        world.notifyBlocksOfNeighborChange(tilePos, this.block);
 
         switch (direction) {
             case SIDE_WEST:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block);
                 break;
             case SIDE_EAST:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block);
                 break;
             case SIDE_NORTH:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block);
                 break;
             case SIDE_SOUTH:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block);
                 break;
             case SIDE_TOP:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block);
                 break;
             case SIDE_BOTTOM:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block);
                 break;
         }
-        world.scheduleBlockUpdate(tilePos, this.block.id(), this.tickDelay());
+        world.scheduleBlockUpdate(tilePos, this.block, this.tickDelay());
         return true;
     }
 
@@ -298,26 +298,26 @@ public class BlockLogicButton
     @Override
     public void onRemoved(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
         if ((data & MASK_POWERED) != 0) {
-            world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
+            world.notifyBlocksOfNeighborChange(tilePos, this.block);
             final int direction = data & MASK_DIRECTION;
             switch (direction) {
                 case SIDE_WEST:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block);
                     break;
                 case SIDE_EAST:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block);
                     break;
                 case SIDE_NORTH:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block);
                     break;
                 case SIDE_SOUTH:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block);
                     break;
                 case SIDE_TOP:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block);
                     break;
                 case SIDE_BOTTOM:
-                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block.id());
+                    world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block);
                     break;
             }
         }
@@ -362,26 +362,26 @@ public class BlockLogicButton
             return;
         }
         world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
-        world.notifyBlocksOfNeighborChange(tilePos, this.block.id());
+        world.notifyBlocksOfNeighborChange(tilePos, this.block);
         final int direction = meta & MASK_DIRECTION;
         switch (direction) {
             case SIDE_WEST:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.WEST, new TilePos()), this.block);
                 break;
             case SIDE_EAST:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.EAST, new TilePos()), this.block);
                 break;
             case SIDE_NORTH:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.NORTH, new TilePos()), this.block);
                 break;
             case SIDE_SOUTH:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.SOUTH, new TilePos()), this.block);
                 break;
             case SIDE_TOP:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.UP, new TilePos()), this.block);
                 break;
             case SIDE_BOTTOM:
-                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block.id());
+                world.notifyBlocksOfNeighborChange(tilePos.add(Direction.DOWN, new TilePos()), this.block);
                 break;
         }
 
@@ -397,11 +397,11 @@ public class BlockLogicButton
     @Override
     public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataRaw(tilePos, Blocks.BUTTON_PLANKS_PAINTED.id(), meta);
+        world.setBlockTypeDataRaw(tilePos, Blocks.BUTTON_PLANKS_PAINTED, meta);
         world.setBlockData(tilePos, meta);
         Blocks.BUTTON_PLANKS_PAINTED.getLogic().setColor(world, tilePos, color);
         if ((meta & MASK_POWERED) != 0) {
-            world.scheduleBlockUpdate(tilePos, Blocks.BUTTON_PLANKS_PAINTED.id(), this.tickDelay());
+            world.scheduleBlockUpdate(tilePos, Blocks.BUTTON_PLANKS_PAINTED, this.tickDelay());
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
index 333592202..b899abe2b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButtonPainted.java
@@ -47,7 +47,7 @@ public class BlockLogicButtonPainted
 
     @Override
     public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        world.setBlockIdNotify(tilePos, Blocks.BUTTON_PLANKS.id());
+        world.setBlockTypeNotify(tilePos, Blocks.BUTTON_PLANKS);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
index 94fe358bf..2b27ba2b2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
@@ -37,7 +37,7 @@ public class BlockLogicCactus
 
     @Override
     public void onPlacedByWorld(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        this.onNeighborChanged(world, tilePos, 0);
+        this.onNeighborChanged(world, tilePos, Blocks.AIR);
     }
 
     @Override
@@ -46,13 +46,13 @@ public class BlockLogicCactus
         if (world.isAirBlock(tilePos.add(Direction.UP, queryPos))) {
             int cactusHeight;
             cactusHeight = 1;
-            while (world.getBlockId(tilePos.sub(0, cactusHeight, 0, queryPos)) == this.block.id()) {
+            while (world.getBlockType(tilePos.sub(0, cactusHeight, 0, queryPos)) == this.block) {
                 cactusHeight++;
             }
             if (cactusHeight < 3) {
                 final int data = world.getBlockData(tilePos);
                 if (data == 15) {
-                    world.setBlockIdNotify(tilePos.add(Direction.UP, queryPos), this.block.id());
+                    world.setBlockTypeNotify(tilePos.add(Direction.UP, queryPos), this.block);
                     world.setBlockDataNotify(tilePos, 0);
                 } else {
                     world.setBlockDataNotify(tilePos, data + 1);
@@ -64,11 +64,13 @@ public class BlockLogicCactus
     private void growCactusOnTop(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final @NotNull TilePos offsetPos = new TilePos(tilePos);
 
-        for (offsetPos.y = tilePos.y() + 1; world.getBlockId(offsetPos) == this.block.id(); offsetPos.y++) {
+        offsetPos.y = tilePos.y() + 1;
+        while (world.getBlockType(offsetPos) == this.block) {
+            offsetPos.y++;
         }
 
         if (world.isAirBlock(offsetPos)) {
-            world.setBlockIdNotify(offsetPos, this.block.id());
+            world.setBlockTypeNotify(offsetPos, this.block);
         }
     }
 
@@ -101,10 +103,10 @@ public class BlockLogicCactus
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!this.canStay(world, tilePos)) {
             this.dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
-            world.setBlockIdNotify(tilePos, 0);
+            world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
@@ -123,8 +125,7 @@ public class BlockLogicCactus
         if (world.getBlockMaterial(tilePos.add(Direction.SOUTH, queryPos)).isSolid()) {
             return false;
         } else {
-            final int idDown = world.getBlockId(tilePos.add(Direction.DOWN, queryPos));
-            return Blocks.hasTag(idDown, BlockTags.GROWS_CACTI);
+            return world.getBlockType(tilePos.add(Direction.DOWN, queryPos)).hasTag(BlockTags.GROWS_CACTI);
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
index 3f8cca862..fc75af867 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
@@ -236,21 +236,21 @@ public class BlockLogicChest
             return;
         }
         TilePos queryPos = new TilePos();
-        final int bN = world.getBlockId(tilePos.north(queryPos));
-        final int bS = world.getBlockId(tilePos.south(queryPos));
-        final int bW = world.getBlockId(tilePos.west(queryPos));
-        final int bE = world.getBlockId(tilePos.east(queryPos));
+        final @NotNull Block<?> bN = world.getBlockType(tilePos.north(queryPos));
+        final @NotNull Block<?> bS = world.getBlockType(tilePos.south(queryPos));
+        final @NotNull Block<?> bW = world.getBlockType(tilePos.west(queryPos));
+        final @NotNull Block<?> bE = world.getBlockType(tilePos.east(queryPos));
         @NotNull Direction direction = Direction.NORTH;
-        if (Blocks.solid[bN] && !Blocks.solid[bS]) {
+        if (bN.solid() && !bS.solid()) {
             direction = Direction.SOUTH;
         }
-        if (Blocks.solid[bS] && !Blocks.solid[bN]) {
+        if (bS.solid() && !bN.solid()) {
             direction = Direction.NORTH;
         }
-        if (Blocks.solid[bW] && !Blocks.solid[bE]) {
+        if (bW.solid() && !bE.solid()) {
             direction = Direction.EAST;
         }
-        if (Blocks.solid[bE] && !Blocks.solid[bW]) {
+        if (bE.solid() && !bW.solid()) {
             direction = Direction.WEST;
         }
 
@@ -258,14 +258,13 @@ public class BlockLogicChest
     }
 
     @Override
-    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final int id) {
-        super.onNeighborChanged(world, tilePos, id);
+    public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        super.onNeighborChanged(world, tilePos, block);
         this.checkIfOtherHalfExists(world, tilePos);
     }
 
     public static boolean isChest(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> b = world.getBlock(tilePos);
-        return b != null && b.getLogic() instanceof BlockLogicChest;
+        return world.getBlockType(tilePos).getLogic() instanceof BlockLogicChest;
     }
 
     public static boolean isSingleChest(final @NotNull World world, final @NotNull TilePos tilePos) {
@@ -401,7 +400,7 @@ public class BlockLogicChest
     @Override
     public void setColor(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
-        world.setBlockIdDataRaw(tilePos, Blocks.CHEST_PLANKS_OAK_PAINTED.id(), meta);
+        world.setBlockTypeDataRaw(tilePos, Blocks.CHEST_PLANKS_OAK_PAINTED, meta);
         world.setBlockData(tilePos, meta);
         Blocks.CHEST_PLANKS_OAK_PAINTED.getLogic().setColor(world, tilePos, color);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
index 8f4b5120e..a8bf7b2d0 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestLegacy.java
@@ -35,7 +35,7 @@ public class BlockLogicChestLegacy
     }
 
     public static boolean isLegacyChest(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = world.getBlock(tilePos);
+        final @Nullable Block<?> block = world.getBlockType(tilePos);
         return block == Blocks.CHEST_LEGACY || block == Blocks.CHEST_LEGACY_PAINTED;
     }
 
@@ -58,7 +58,7 @@ public class BlockLogicChestLegacy
             this.updateLegacyChest(world, tilePos);
         }
 
-        return Objects.requireNonNull(world.getBlock(tilePos)).onInteracted(world, tilePos, player, side, xHit, yHit);
+        return Objects.requireNonNull(world.getBlockType(tilePos)).onInteracted(world, tilePos, player, side, xHit, yHit);
     }
 
     private void updateLegacyChest(final @NotNull World world, final @NotNull TilePosc tilePos) {
@@ -210,7 +210,7 @@ public class BlockLogicChestLegacy
         }
         final int legacyChestMeta = world.getBlockData(tilePos);
 
-        final @Nullable Block<?> oldBlock = world.getBlock(tilePos);
+        final @Nullable Block<?> oldBlock = world.getBlockType(tilePos);
         @NotNull Block<?> newBlock = Blocks.CHEST_PLANKS_OAK;
 
         if (oldBlock == Blocks.CHEST_LEGACY_PAINTED) {
@@ -218,7 +218,7 @@ public class BlockLogicChestLegacy
             newMeta = newMeta | (legacyChestMeta << 4);
         }
 
-        world.setBlockIdData(tilePos, newBlock.id(), newMeta);
+        world.setBlockTypeData(tilePos, newBlock, newMeta);
         world.markBlockNeedsUpdate(tilePos);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java
index f36307806..96902d915 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChestPainted.java
@@ -51,7 +51,7 @@ public class BlockLogicChestPainted
     @Override
     public void removeDye(final @NotNull World world, final @NotNull TilePosc tilePos) {
         final int meta = this.stripColorFromMetadata(world.getBlockData(tilePos));
-        world.setBlockIdDataNotify(tilePos, Blocks.CHEST_PLANKS_OAK.id(), meta);
+        world.setBlockTypeDataNotify(tilePos, Blocks.CHEST_PLANKS_OAK, meta);
     }
 
     @Override
